/*
 *                      EBUILDA: cross-platform build system
 *
 * This file is part of Yeppp! library infrastructure and licensed under Simplified BSD License.
 * See LICENSE.txt for the full text of the license.
 *
 */

package info.yeppp.ebuilda;

/*
public class GnuLibrarian extends AbstractLibrarian {
	public GnuLibrarian() {
	}

	public BuildMessages createStaticLibrary(String libraryPath, Collection<String> objectPaths) {
		if (binariesDirectory == null) {
			throw new IllegalStateException("Binaries directory was not assigned any value");
		}
		final BuildMessages buildMessages = new BuildMessages();

		final List<String> commands = new ArrayList<String>();
		commands.add("ar");
		commands.add("-cq");
		final String libraryDirectoryPath = libraryPath.substring(0, libraryPath.lastIndexOf(SystemUtils.FILE_SEPARATOR));
		final String libraryFilePath = libraryPath.substring(libraryPath.lastIndexOf(SystemUtils.FILE_SEPARATOR) + 1);
		commands.add(FilenameUtils.concat(libraryDirectoryPath, "lib" + libraryFilePath + ".a"));
        FileUtils.deleteQuietly(new File(FilenameUtils.concat(libraryDirectoryPath, "lib" + libraryFilePath + ".a")));
		for (String objectPath : objectPaths) {
			commands.add(objectPath);
		}
		for (String library : libraries) {
			commands.add(library);
		}
		final String[] environment = prepareEnvironment();
		try {
            System.out.println(StringUtils.join(commands, " "));
			final Process process = Runtime.getRuntime().exec(commands.toArray(new String[commands.size()]), environment);
			process.waitFor();
			final InputStream stderr = process.getErrorStream();
			final InputStream stdout = process.getInputStream();
			final BufferedReader stderrReader = new BufferedReader(new InputStreamReader(stderr, Charset.forName("CP866")));
			final BufferedReader stdoutReader = new BufferedReader(new InputStreamReader(stdout, Charset.forName("CP866")));
			String line = stderrReader.readLine();
			while (line != null) {
				System.out.println(line);

				line = stderrReader.readLine();
			}
			line = stdoutReader.readLine();
			while (line != null) {
				System.out.println(line);

				line = stdoutReader.readLine();
			}
		} catch (IOException exception) {
			buildMessages.add(new BuildMessage(BuildMessage.Type.Exception, libraryPath, null, null, exception.getMessage()));
		} catch (InterruptedException exception) {
			buildMessages.add(new BuildMessage(BuildMessage.Type.Exception, libraryPath, null, null, exception.getMessage()));
		}
		return buildMessages;
	}

	private String[] prepareEnvironment() {
		final List<String> environment = new ArrayList<String>();
		boolean addedLibs = false;
		for (Map.Entry<String, String> variable : System.getenv().entrySet()) {
			if (variable.getKey().equalsIgnoreCase("LIB") && !globalLibraryDirectories.isEmpty()) {
				addedLibs = true;
				final String variableDeclaration = variable.getKey() +
						"=" + StringUtils.join(globalLibraryDirectories, SystemUtils.PATH_SEPARATOR) +
						SystemUtils.PATH_SEPARATOR + variable.getValue();
				environment.add(variableDeclaration);
			} else {
				final String variableDeclaration = variable.getKey() + "=" + variable.getValue();
				environment.add(variableDeclaration);
			}
		}
		if (addedLibs == false) {
			environment.add("LIB=" + StringUtils.join(globalLibraryDirectories, SystemUtils.PATH_SEPARATOR));
		}
		return environment.toArray(new String[environment.size()]);
	}

	public void addDefaultGlobalLibraryDirectories() {
	}
}
*/