package info.yeppp.ebuilda;

import info.yeppp.ebuilda.filesystem.AbsoluteFilePath;
import info.yeppp.ebuilda.internals.Program;

public class PassThroughOutputParser implements Program.EventHandler {

	public PassThroughOutputParser(BuildMessages messages, AbsoluteFilePath sourcePath) {
		this.messages = messages;
		this.sourcePath = sourcePath;
	}

	private final BuildMessages messages;
	private final AbsoluteFilePath sourcePath;

	@Override
	public void onStdOutLineWrite(String line) {
		System.out.println(line);
	}

	@Override
	public void onStdErrLineWrite(String line) {
		System.err.println(line);
	}

	@Override
	public void onError(String description) {
		messages.add(new BuildMessage(BuildMessage.Type.Exception, sourcePath, null, null, description));
	}

	@Override
	public void onCompletion(Integer status) {
	}

}
