/*
 *                      EBUILDA: cross-platform build system
 *
 * This file is part of Yeppp! library infrastructure and licensed under Simplified BSD License.
 * See LICENSE.txt for the full text of the license.
 *
 */

package info.yeppp.ebuilda.generic;

import info.yeppp.ebuilda.BuildMessages;
import info.yeppp.ebuilda.filesystem.AbsoluteDirectoryPath;
import info.yeppp.ebuilda.filesystem.AbsoluteFilePath;

public interface JavaCompiler {

	public BuildMessages compile(AbsoluteFilePath sourcePath);

	public AbsoluteFilePath getObjectPath(AbsoluteFilePath sourcePath);

	public void setSourceDirectory(AbsoluteDirectoryPath sourceDirectory);

	public AbsoluteDirectoryPath getSourceDirectory();

	public void setClassDirectory(AbsoluteDirectoryPath classDirectory);

	public AbsoluteDirectoryPath getClassDirectory();

	public void setDebugBuild(boolean debugEnabled);

	public boolean isDebugBuild();

	public void setVerboseBuild(boolean verboseBuild);

	public boolean isVerboseBuild();

	public boolean addClassPathDirectory(AbsoluteDirectoryPath classPath);

	public boolean removeClassPathDirectory(AbsoluteDirectoryPath classPath);

	public void clearClassPathDirectories();

	public JavaCompiler copy();

}
