/*
 *                      EBUILDA: cross-platform build system
 *
 * This file is part of Yeppp! library infrastructure and licensed under Simplified BSD License.
 * See LICENSE.txt for the full text of the license.
 *
 */

package info.yeppp.ebuilda.generic;

import info.yeppp.ebuilda.BuildMessages;

import java.util.Collection;

public interface Librarian {
	public BuildMessages createStaticLibrary(String libraryPath, Collection<String> objectPaths);

	public void setBinariesDirectory(String binariesDirectory);

	public String getBinariesDirectory();

	public void setObjectDirectory(String objectDirectory);

	public String getObjectDirectory();

	public boolean addLibraryDependence(String libraryName);

	public boolean removeLibraryDependence(String libraryName);

	public void clearLibraryDependences();

	public void addDefaultGlobalLibraryDirectories();

	public boolean addGlobalLibraryDirectory(String libraryDirectory);

	public boolean removeGlobalLibraryDirectory(String libraryDirectory);

	public void clearGlobalLibraryDirectories();

	public boolean addLibraryDirectory(String libraryDirectory);

	public boolean removeLibraryDirectory(String libraryDirectory);

	public void clearLibraryDirectories();
}
