/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See LICENSE.txt for the full text of the license.
 */

#include <jni.h>
#include <yepPrivate.h>
#include <yepCore.h>
#include <yepJavaPrivate.h>


JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sV8s_1V8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jbyteArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;
	Yep8s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8sV8s_V8s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sV8s_1V16s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8sV8s_V16s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8uV8u_1V16u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep16u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8uV8u_V16u(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sV16s_1V16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16sV16s_V16s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sV16s_1V32s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16sV16s_V32s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16uV16u_1V32u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep32u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16uV16u_V32u(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sV32s_1V32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32sV32s_V32s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sV32s_1V64s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32sV32s_V64s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32uV32u_1V64u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep64u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32uV32u_V64u(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64sV64s_1V64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep64s* yPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V64sV64s_V64s(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jfloatArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;
	Yep32f* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32fV32f_V32f(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jdoubleArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;
	Yep64f* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V64fV64f_V64f(&xPointer[xOffset], &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sS8s_1V8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jbyteArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8sS8s_V8s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sS8s_1V16s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8sS8s_V16s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8uS8u_1V16u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep16u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V8uS8u_V16u(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sS16s_1V16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16sS16s_V16s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sS16s_1V32s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16sS16s_V32s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16uS16u_1V32u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep32u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V16uS16u_V32u(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sS32s_1V32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32sS32s_V32s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sS32s_1V64s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32sS32s_V64s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32uS32u_1V64u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep64u* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32uS32u_V64u(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64sS64s_1V64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlong y, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V64sS64s_V64s(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32fS32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jfloatArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V32fS32f_V32f(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64fS64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jdoubleArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* diffPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_V64fS64f_V64f(&xPointer[xOffset], y, &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S8sV8s_1V8s(JNIEnv *env, jclass class, jbyte x, jbyteArray yArray, jint yOffset, jbyteArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* yPointer = NULL;
	Yep8s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S8sV8s_V8s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S8sV8s_1V16s(JNIEnv *env, jclass class, jbyte x, jbyteArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8s* yPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S8sV8s_V16s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S8uV8u_1V16u(JNIEnv *env, jclass class, jbyte x, jbyteArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep8u* yPointer = NULL;
	Yep16u* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S8uV8u_V16u(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S16sV16s_1V16s(JNIEnv *env, jclass class, jshort x, jshortArray yArray, jint yOffset, jshortArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* yPointer = NULL;
	Yep16s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S16sV16s_V16s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S16sV16s_1V32s(JNIEnv *env, jclass class, jshort x, jshortArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16s* yPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S16sV16s_V32s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S16uV16u_1V32u(JNIEnv *env, jclass class, jshort x, jshortArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep16u* yPointer = NULL;
	Yep32u* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S16uV16u_V32u(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32sV32s_1V32s(JNIEnv *env, jclass class, jint x, jintArray yArray, jint yOffset, jintArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* yPointer = NULL;
	Yep32s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S32sV32s_V32s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32sV32s_1V64s(JNIEnv *env, jclass class, jint x, jintArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32s* yPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S32sV32s_V64s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32uV32u_1V64u(JNIEnv *env, jclass class, jint x, jintArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32u* yPointer = NULL;
	Yep64u* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S32uV32u_V64u(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S64sV64s_1V64s(JNIEnv *env, jclass class, jlong x, jlongArray yArray, jint yOffset, jlongArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64s* yPointer = NULL;
	Yep64s* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S64sV64s_V64s(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32fV32f_1V32f(JNIEnv *env, jclass class, jfloat x, jfloatArray yArray, jint yOffset, jfloatArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep32f* yPointer = NULL;
	Yep32f* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S32fV32f_V32f(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S64fV64f_1V64f(JNIEnv *env, jclass class, jdouble x, jdoubleArray yArray, jint yOffset, jdoubleArray diffArray, jint diffOffset, jint length) {
	enum YepStatus status;
	Yep64f* yPointer = NULL;
	Yep64f* diffPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(diffArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument diffArray is null");
		return;
	}
	if YEP_UNLIKELY(diffOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument diffOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)diffOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, diffArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "diffOffset + length exceed the length of diffArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	diffPointer = (*env)->GetPrimitiveArrayCritical(env, diffArray, NULL);

	status = yepCore_Subtract_S64fV64f_V64f(x, &yPointer[yOffset], &diffPointer[diffOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, diffArray, diffPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV8sV8s_1IV8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV8sV8s_IV8s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV16sV16s_1IV16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV16sV16s_IV16s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV32sV32s_1IV32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV32sV32s_IV32s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV64sV64s_1IV64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep64s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV64sV64s_IV64s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV32fV32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV32fV32f_IV32f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV64fV64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_IV64fV64f_IV64f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V8sIV8s_1IV8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V8sIV8s_IV8s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V16sIV16s_1IV16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V16sIV16s_IV16s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32sIV32s_1IV32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V32sIV32s_IV32s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64sIV64s_1IV64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep64s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V64sIV64s_IV64s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V32fIV32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V32fIV32f_IV32f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1V64fIV64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_V64fIV64f_IV64f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV8sS8s_1IV8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV8sS8s_IV8s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV16sS16s_1IV16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV16sS16s_IV16s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV32sS32s_1IV32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV32sS32s_IV32s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV64sS64s_1IV64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlong y, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV64sS64s_IV64s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV32fS32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV32fS32f_IV32f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1IV64fS64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Subtract_IV64fS64f_IV64f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S8sIV8s_1IV8s(JNIEnv *env, jclass class, jbyte x, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8s* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S8sIV8s_IV8s(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S16sIV16s_1IV16s(JNIEnv *env, jclass class, jshort x, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16s* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S16sIV16s_IV16s(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32sIV32s_1IV32s(JNIEnv *env, jclass class, jint x, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32s* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S32sIV32s_IV32s(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S64sIV64s_1IV64s(JNIEnv *env, jclass class, jlong x, jlongArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64s* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S64sIV64s_IV64s(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S32fIV32f_1IV32f(JNIEnv *env, jclass class, jfloat x, jfloatArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32f* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S32fIV32f_IV32f(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Subtract_1S64fIV64f_1IV64f(JNIEnv *env, jclass class, jdouble x, jdoubleArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64f* yPointer = NULL;

	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Subtract_S64fIV64f_IV64f(x, &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}
